$IF .NOT. DEFINED (COMCTLTY_ )
$DEFINE COMCTLTY_  

MODULE COMCTLTY

USE MSFWINTY,ONLY: COMT_RECT=>T_RECT,COMT_POINT=>T_POINT,   &
             CCHDEVICENAME,CCHFORMNAME,WM_USER

!==== Menus ===========================================================

INTEGER,PARAMETER:: MIIM_STATE       =#00000001
INTEGER,PARAMETER:: MIIM_ID          =#00000002
INTEGER,PARAMETER:: MIIM_SUBMENU     =#00000004
INTEGER,PARAMETER:: MIIM_CHECKMARKS  =#00000008
INTEGER,PARAMETER:: MIIM_TYPE        =#00000010
INTEGER,PARAMETER:: MIIM_DATA        =#00000020

INTEGER,PARAMETER:: MFT_STRING          =#00000000
INTEGER,PARAMETER:: MFT_BITMAP          =#00000004
INTEGER,PARAMETER:: MFT_MENUBARBREAK    =#00000020
INTEGER,PARAMETER:: MFT_MENUBREAK       =#00000040
INTEGER,PARAMETER:: MFT_OWNERDRAW       =#00000100
INTEGER,PARAMETER:: MFT_RADIOCHECK      =#00000200
INTEGER,PARAMETER:: MFT_SEPARATOR       =#00000800
INTEGER,PARAMETER:: MFT_RIGHTORDER      =#00002000
INTEGER,PARAMETER:: MFT_RIGHTJUSTIFY    =#00004000

INTEGER,PARAMETER:: MFS_GRAYED          =#00000003
INTEGER,PARAMETER:: MFS_DISABLED        =MFS_GRAYED
INTEGER,PARAMETER:: MFS_CHECKED         =#00000008
INTEGER,PARAMETER:: MFS_HILITE          =#00000080
INTEGER,PARAMETER:: MFS_ENABLED         =#00000000
INTEGER,PARAMETER:: MFS_UNCHECKED       =#00000000
INTEGER,PARAMETER:: MFS_UNHILITE        =#00000000
INTEGER,PARAMETER:: MFS_DEFAULT         =#00001000

TYPE T_MENUITEMINFO
    INTEGER(4)    cbSize
    INTEGER(4)    fMask
    INTEGER(4)    fType
    INTEGER(4)    fState
    INTEGER(4)    wID
    INTEGER(4)    hSubMenu
    INTEGER(4)    hbmpChecked
    INTEGER(4)    hbmpUnchecked
    INTEGER(4)    dwItemData
    INTEGER(4)    dwTypeData
    INTEGER(4)    cch
END TYPE T_MENUITEMINFO


!==== Toolbars ========================================================

INTEGER,PARAMETER:: WM_HELP                 =#0053

$IF .NOT. DEFINED (_DVF)
TYPE T_NMHDR
    INTEGER(4)    hwndFrom
    INTEGER(4)    idFrom
    INTEGER(4)    code
END TYPE T_NMHDR

TYPE T_TBBUTTON
    INTEGER(4)    iBitmap
    INTEGER(4)    idCommand
    BYTE          fsState
    BYTE          fsStyle 
    BYTE          iReserved(2)
    INTEGER(4)    dwData 
    INTEGER(4)    iString
END TYPE T_TBBUTTON

TYPE T_TBNOTIFY
    TYPE(T_NMHDR) hdr
    INTEGER(4)    iItem 
    INTEGER(4)    tbButton 
    INTEGER(4)    cchText 
    INTEGER(4)    pszText 
END TYPE T_TBNOTIFY

TYPE T_COLORMAP
    INTEGER(4)    from
    INTEGER(4)    to
END TYPE T_COLORMAP

TYPE T_TBADDBITMAP
    INTEGER(4)    hInst
    INTEGER(4)    nID
END TYPE T_TBADDBITMAP


INTEGER,PARAMETER:: IDB_STD_SMALL_COLOR     =0
INTEGER,PARAMETER:: IDB_STD_LARGE_COLOR     =1
INTEGER,PARAMETER:: IDB_VIEW_SMALL_COLOR    =4
INTEGER,PARAMETER:: IDB_VIEW_LARGE_COLOR    =5

!Icon indexes for standard bitmap
INTEGER,PARAMETER:: STD_CUT                 =0
INTEGER,PARAMETER:: STD_COPY                =1
INTEGER,PARAMETER:: STD_PASTE               =2
INTEGER,PARAMETER:: STD_UNDO                =3
INTEGER,PARAMETER:: STD_REDOW               =4
INTEGER,PARAMETER:: STD_DELETE              =5
INTEGER,PARAMETER:: STD_FILENEW             =6
INTEGER,PARAMETER:: STD_FILEOPEN            =7
INTEGER,PARAMETER:: STD_FILESAVE            =8
INTEGER,PARAMETER:: STD_PRINTPRE            =9
INTEGER,PARAMETER:: STD_PROPERTIES          =10
INTEGER,PARAMETER:: STD_HELP                =11
INTEGER,PARAMETER:: STD_FIND                =12
INTEGER,PARAMETER:: STD_REPLACE             =13
INTEGER,PARAMETER:: STD_PRINT               =14

!Icon indexes for standard view bitmap
INTEGER,PARAMETER:: VIEW_LARGEICONS         =0
INTEGER,PARAMETER:: VIEW_SMALLICONS         =1
INTEGER,PARAMETER:: VIEW_LIST               =2
INTEGER,PARAMETER:: VIEW_DETAILS            =3
INTEGER,PARAMETER:: VIEW_SORTNAME           =4
INTEGER,PARAMETER:: VIEW_SORTSIZE           =5
INTEGER,PARAMETER:: VIEW_SORTDATE           =6
INTEGER,PARAMETER:: VIEW_SORTTYPE           =7
INTEGER,PARAMETER:: VIEW_PARENTFOLDER       =8
INTEGER,PARAMETER:: VIEW_NETCONNECT         =9
INTEGER,PARAMETER:: VIEW_NETDISCONNECT      =10
INTEGER,PARAMETER:: VIEW_NEWFOLDER          =11

INTEGER,PARAMETER:: CMB_MASKED              =#02

INTEGER,PARAMETER:: TBSTATE_CHECKED         =#01
INTEGER,PARAMETER:: TBSTATE_PRESSED         =#02
INTEGER,PARAMETER:: TBSTATE_ENABLED         =#04
INTEGER,PARAMETER:: TBSTATE_HIDDEN          =#08
INTEGER,PARAMETER:: TBSTATE_INDETERMINATE   =#10
INTEGER,PARAMETER:: TBSTATE_WRAP            =#20

INTEGER,PARAMETER:: TBSTYLE_BUTTON          =#00
INTEGER,PARAMETER:: TBSTYLE_SEP             =#01
INTEGER,PARAMETER:: TBSTYLE_CHECK           =#02
INTEGER,PARAMETER:: TBSTYLE_GROUP           =#04
!INTEGER,PARAMETER:: TBSTYLE_CHECKGROUP      =#06

INTEGER,PARAMETER:: TBSTYLE_TOOLTIPS        =#0100
INTEGER,PARAMETER:: TBSTYLE_WRAPABLE        =#0200
INTEGER,PARAMETER:: TBSTYLE_ALTDRAG         =#0400

INTEGER,PARAMETER:: WM_USER_1               =#0400
INTEGER,PARAMETER:: TB_ENABLEBUTTON         =#0401
INTEGER,PARAMETER:: TB_CHECKBUTTON          =#0402
INTEGER,PARAMETER:: TB_PRESSBUTTON          =#0403
INTEGER,PARAMETER:: TB_HIDEBUTTON           =#0404
INTEGER,PARAMETER:: TB_INDETERMINATE        =#0405
INTEGER,PARAMETER:: TB_ISBUTTONENABLED      =#0409
INTEGER,PARAMETER:: TB_ISBUTTONCHECKED      =#040A
INTEGER,PARAMETER:: TB_ISBUTTONPRESSED      =#040B
INTEGER,PARAMETER:: TB_ISBUTTONHIDDEN       =#040C
INTEGER,PARAMETER:: TB_ISBUTTONINDETERMINATE =#040D
INTEGER,PARAMETER:: TB_SETSTATE             =#0411
INTEGER,PARAMETER:: TB_GETSTATE             =#0412
INTEGER,PARAMETER:: TB_ADDBITMAP            =#0413

INTEGER,PARAMETER:: TB_ADDBUTTONS           =#0414
INTEGER,PARAMETER:: TB_INSERTBUTTON         =#0415
INTEGER,PARAMETER:: TB_DELETEBUTTON         =#0416
INTEGER,PARAMETER:: TB_GETBUTTON            =#0417
INTEGER,PARAMETER:: TB_BUTTONCOUNT          =#0418
INTEGER,PARAMETER:: TB_COMMANDTOINDEX       =#0419

INTEGER,PARAMETER:: TB_SAVERESTOREA         =#041A
INTEGER,PARAMETER:: TB_SAVERESTOREW         =#044C
INTEGER,PARAMETER:: TB_CUSTOMIZE            =#041B
INTEGER,PARAMETER:: TB_ADDSTRINGA           =#041C
INTEGER,PARAMETER:: TB_ADDSTRINGW           =#044D
INTEGER,PARAMETER:: TB_GETITEMRECT          =#041D
INTEGER,PARAMETER:: TB_BUTTONSTRUCTSIZE     =#041E
INTEGER,PARAMETER:: TB_SETBUTTONSIZE        =#041F
INTEGER,PARAMETER:: TB_SETBITMAPSIZE        =#0420
INTEGER,PARAMETER:: TB_AUTOSIZE             =#0421
INTEGER,PARAMETER:: TB_GETTOOLTIPS          =#0423
INTEGER,PARAMETER:: TB_SETTOOLTIPS          =#0424
INTEGER,PARAMETER:: TB_SETPARENT            =#0425
INTEGER,PARAMETER:: TB_SETROWS              =#0427
INTEGER,PARAMETER:: TB_GETROWS              =#0428
INTEGER,PARAMETER:: TB_SETCMDID             =#042A
INTEGER,PARAMETER:: TB_CHANGEBITMAP         =#042B
INTEGER,PARAMETER:: TB_GETBITMAP            =#042C
INTEGER,PARAMETER:: TB_GETBUTTONTEXTA       =#042D
INTEGER,PARAMETER:: TB_GETBUTTONTEXTW       =#044B
INTEGER,PARAMETER:: TB_REPLACEBITMAP        =#042E

INTEGER,PARAMETER:: TB_GETBUTTONTEXT        =#042D
INTEGER,PARAMETER:: TB_SAVERESTORE          =#041A
INTEGER,PARAMETER:: TB_ADDSTRING            =#041C

!==== Load Image ======================================================

INTEGER,PARAMETER:: IMAGE_BITMAP            =0
INTEGER,PARAMETER:: IMAGE_ICON              =1
INTEGER,PARAMETER:: IMAGE_CURSOR            =2
INTEGER,PARAMETER:: IMAGE_ENHMETAFILE       =3

INTEGER,PARAMETER:: LR_DEFAULTCOLOR         =#0000
INTEGER,PARAMETER:: LR_MONOCHROME           =#0001
INTEGER,PARAMETER:: LR_COLOR                =#0002
INTEGER,PARAMETER:: LR_COPYRETURNORG        =#0004
INTEGER,PARAMETER:: LR_COPYDELETEORG        =#0008
INTEGER,PARAMETER:: LR_LOADFROMFILE         =#0010
INTEGER,PARAMETER:: LR_LOADTRANSPARENT      =#0020
INTEGER,PARAMETER:: LR_DEFAULTSIZE          =#0040
INTEGER,PARAMETER:: LR_LOADMAP3DCOLORS      =#1000
INTEGER,PARAMETER:: LR_CREATEDIBSECTION     =#2000
INTEGER,PARAMETER:: LR_COPYFROMRESOURCE     =#4000
INTEGER,PARAMETER:: LR_SHARED               =#8000    

!==== Missing messages ================================================

INTEGER,PARAMETER:: WM_NOTIFY               =#004E
INTEGER,PARAMETER:: WM_INPUTLANGCHANGEREQUEST =#0050
INTEGER,PARAMETER:: WM_INPUTLANGCHANGE      =#0051
INTEGER,PARAMETER:: WM_TCARD                =#0052
INTEGER,PARAMETER:: WM_USERCHANGED          =#0054
INTEGER,PARAMETER:: WM_NOTIFYFORMAT         =#0055

INTEGER,PARAMETER:: NFR_ANSI                    =1
INTEGER,PARAMETER:: NFR_UNICODE                 =2
INTEGER,PARAMETER:: NF_QUERY                    =3
INTEGER,PARAMETER:: NF_REQUERY                  =4

INTEGER,PARAMETER:: WM_CONTEXTMENU          =#007B
INTEGER,PARAMETER:: WM_STYLECHANGING        =#007C
INTEGER,PARAMETER:: WM_STYLECHANGED         =#007D
INTEGER,PARAMETER:: WM_DISPLAYCHANGE        =#007E
INTEGER,PARAMETER:: WM_GETICON              =#007F
INTEGER,PARAMETER:: WM_SETICON              =#0080

!==== Tooltips ========================================================

TYPE T_TTTOOLINFO
    INTEGER(4)    cbSize 
    INTEGER(4)    uFlags 
    INTEGER(4)    hwnd 
    INTEGER(4)    uId 
    TYPE(COMT_RECT)  rect 
    INTEGER(4)    hinst
    INTEGER(4)    lpszText
    INTEGER(4)    fMode
END TYPE T_TTTOOLINFO

TYPE T_TOOLTIPTEXT
    TYPE(T_NMHDR) hdr
    INTEGER(4)    lpszText
    CHARACTER*80  szText
    INTEGER(4)    hinst 
    INTEGER(4)    uFlags
END TYPE T_TOOLTIPTEXT

TYPE T_HITTESTINFO
    INTEGER(4)    hwnd
    TYPE(COMT_POINT) pt 
    TYPE(T_TTTOOLINFO) ti
END TYPE T_HITTESTINFO

INTEGER,PARAMETER:: TTS_ALWAYSTIP           =#01
INTEGER,PARAMETER:: TTS_NOPREFIX            =#02

INTEGER,PARAMETER:: TTF_IDISHWND            =#01
INTEGER,PARAMETER:: TTF_CENTERTIP           =#02
INTEGER,PARAMETER:: TTF_RTLREADING          =#04
INTEGER,PARAMETER:: TTF_SUBCLASS            =#10

INTEGER,PARAMETER:: TTDT_AUTOMATIC          =0
INTEGER,PARAMETER:: TTDT_RESHOW             =1
INTEGER,PARAMETER:: TTDT_AUTOPOP            =2
INTEGER,PARAMETER:: TTDT_INITIAL            =3

INTEGER,PARAMETER:: TTM_ACTIVATE            =#0401
INTEGER,PARAMETER:: TTM_SETDELAYTIME        =#0403
INTEGER,PARAMETER:: TTM_ADDTOOL             =#0404
INTEGER,PARAMETER:: TTM_DELTOOL             =#0405
INTEGER,PARAMETER:: TTM_NEWTOOLRECT         =#0406
INTEGER,PARAMETER:: TTM_RELAYEVENT          =#0407
INTEGER,PARAMETER:: TTM_GETTOOLINFO         =#0408
INTEGER,PARAMETER:: TTM_SETTOOLINFO         =#0409
INTEGER,PARAMETER:: TTM_HITTEST             =#040A
INTEGER,PARAMETER:: TTM_GETTEXT             =#040B
INTEGER,PARAMETER:: TTM_UPDATETIPTEXT       =#040C
INTEGER,PARAMETER:: TTM_GETTOOLCOUNT        =#040D
INTEGER,PARAMETER:: TTM_ENUMTOOLS           =#040E
INTEGER,PARAMETER:: TTM_GETCURRENTTOOL      =#040F
INTEGER,PARAMETER:: TTM_WINDOWFROMPOINT     =#0410

INTEGER, PARAMETER:: TTN_NEEDTEXT           =-520
INTEGER, PARAMETER:: TTN_NEEDTEXTA          =-520
INTEGER, PARAMETER:: TTN_NEEDTEXTW          =-530
INTEGER, PARAMETER:: TTN_SHOW               =-521
INTEGER, PARAMETER:: TTN_POP                =-522

!==== Scrollbars ======================================================

TYPE T_SCROLLINFO
      INTEGER Size 
      INTEGER Mask 
      INTEGER Min 
      INTEGER Max 
      INTEGER Page 
      INTEGER Pos 
      INTEGER TrackPos
END type T_SCROLLINFO

TYPE(T_SCROLLINFO), POINTER:: NULL_SCROLLINFO

INTEGER*4, PARAMETER, PUBLIC :: SIF_RANGE             = #0001
INTEGER*4, PARAMETER, PUBLIC :: SIF_PAGE              = #0002
INTEGER*4, PARAMETER, PUBLIC :: SIF_POS               = #0004     
INTEGER*4, PARAMETER, PUBLIC :: SIF_DISABLENOSCROLL   = #0008
INTEGER*4, PARAMETER, PUBLIC :: SIF_TRACKPOS          = #0010
INTEGER*4, PARAMETER, PUBLIC :: SIF_ALL               = #0017

!==== Buttons ======================================================

INTEGER*4 ,PARAMETER, PUBLIC :: BS_TEXT               = #00000000
INTEGER*4 ,PARAMETER, PUBLIC :: BS_ICON               = #00000040
INTEGER*4 ,PARAMETER, PUBLIC :: BS_BITMAP             = #00000080
INTEGER*4 ,PARAMETER, PUBLIC :: BS_LEFT               = #00000100
INTEGER*4 ,PARAMETER, PUBLIC :: BS_RIGHT              = #00000200
INTEGER*4 ,PARAMETER, PUBLIC :: BS_CENTER             = #00000300
INTEGER*4 ,PARAMETER, PUBLIC :: BS_TOP                = #00000400
INTEGER*4 ,PARAMETER, PUBLIC :: BS_BOTTOM             = #00000800
INTEGER*4 ,PARAMETER, PUBLIC :: BS_VCENTER            = #00000C00
INTEGER*4 ,PARAMETER, PUBLIC :: BS_MULTILINE          = #00002000
INTEGER*4 ,PARAMETER, PUBLIC :: BS_NOTIFY             = #00004000
INTEGER*4 ,PARAMETER, PUBLIC :: BS_FLAT               = #00008000

INTEGER*4 ,PARAMETER, PUBLIC :: BM_CLICK              = #00F5
INTEGER*4 ,PARAMETER, PUBLIC :: BM_GETIMAGE           = #00F6
INTEGER*4 ,PARAMETER, PUBLIC :: BM_SETIMAGE           = #00F7

INTEGER*4 ,PARAMETER, PUBLIC :: BST_UNCHECKED         = #0000
INTEGER*4 ,PARAMETER, PUBLIC :: BST_CHECKED           = #0001
INTEGER*4 ,PARAMETER, PUBLIC :: BST_INDETERMINATE     = #0002
INTEGER*4 ,PARAMETER, PUBLIC :: BST_PUSHED            = #0004
INTEGER*4 ,PARAMETER, PUBLIC :: BST_FOCUS             = #0008

!==== Device capabilities ====================================================

!INTEGER, PARAMETER:: DM_BITSPERPEL       =#00040000
!INTEGER, PARAMETER:: DM_PELSWIDTH        =#00080000
!INTEGER, PARAMETER:: DM_PELSHEIGHT       =#00100000
!INTEGER, PARAMETER:: DM_DISPLAYFLAGS     =#00200000
!INTEGER, PARAMETER:: DM_DISPLAYFREQUENCY =#00400000

INTEGER, PARAMETER:: DISP_CHANGE_SUCCESSFUL       =0
INTEGER, PARAMETER:: DISP_CHANGE_RESTART          =1
INTEGER, PARAMETER:: DISP_CHANGE_FAILED          =-1
INTEGER, PARAMETER:: DISP_CHANGE_BADMODE         =-2
INTEGER, PARAMETER:: DISP_CHANGE_NOTUPDATED      =-3
INTEGER, PARAMETER:: DISP_CHANGE_BADFLAGS        =-4

!==== Status bars ========================================================

INTEGER, PARAMETER:: SB_SETTEXT           =#0401
INTEGER, PARAMETER:: SB_GETTEXT           =#0402
INTEGER, PARAMETER:: SB_GETTEXTLENGTH     =#0403
INTEGER, PARAMETER:: SB_SETPARTS          =#0404
INTEGER, PARAMETER:: SB_GETPARTS          =#0406
INTEGER, PARAMETER:: SB_GETBORDERS        =#0407
INTEGER, PARAMETER:: SB_SETMINHEIGHT      =#0408
INTEGER, PARAMETER:: SB_SIMPLE            =#0409
INTEGER, PARAMETER:: SB_GETRECT           =#040A


!==== Up-down controls =======================================================


TYPE T_UDACCEL
    INTEGER nSec
    INTEGER nInc
END TYPE T_UDACCEL


INTEGER,PARAMETER:: UD_MAXVAL               =#7fff
INTEGER,PARAMETER:: UD_MINVAL               =#1


INTEGER,PARAMETER:: UDS_WRAP                =#0001
INTEGER,PARAMETER:: UDS_SETBUDDYINT         =#0002
INTEGER,PARAMETER:: UDS_ALIGNRIGHT          =#0004
INTEGER,PARAMETER:: UDS_ALIGNLEFT           =#0008
INTEGER,PARAMETER:: UDS_AUTOBUDDY           =#0010
INTEGER,PARAMETER:: UDS_ARROWKEYS           =#0020
INTEGER,PARAMETER:: UDS_HORZ                =#0040
INTEGER,PARAMETER:: UDS_NOTHOUSANDS         =#0080

INTEGER,PARAMETER:: UDM_SETRANGE            =#0465
INTEGER,PARAMETER:: UDM_GETRANGE            =#0466
INTEGER,PARAMETER:: UDM_SETPOS              =#0467
INTEGER,PARAMETER:: UDM_GETPOS              =#0468
INTEGER,PARAMETER:: UDM_SETBUDDY            =#0469
INTEGER,PARAMETER:: UDM_GETBUDDY            =#0470
INTEGER,PARAMETER:: UDM_SETACCEL            =#0471
INTEGER,PARAMETER:: UDM_GETACCEL            =#0472
INTEGER,PARAMETER:: UDM_SETBASE             =#0473
INTEGER,PARAMETER:: UDM_GETBASE             =#0474

TYPE T_NM_UPDOWN
    TYPE (T_NMHDR) hdr
    INTEGER iPos
    INTEGER iDelta
END TYPE T_NM_UPDOWN

INTEGER,PARAMETER::     UDN_DELTAPOS =-722
!==== Progress bars =======================================================

INTEGER, PARAMETER:: PBM_SETRANGE         =#0401
INTEGER, PARAMETER:: PBM_SETPOS           =#0402
INTEGER, PARAMETER:: PBM_DELTAPOS         =#0403
INTEGER, PARAMETER:: PBM_SETSTEP          =#0404
INTEGER, PARAMETER:: PBM_STEPIT           =#0405

!==== Tab controls ========================================================

CHARACTER*16,PARAMETER::   WC_TABCONTROL ="SysTabControl32"C

INTEGER,PARAMETER:: TCS_FORCEICONLEFT       =#0010
INTEGER,PARAMETER:: TCS_FORCELABELLEFT      =#0020
INTEGER,PARAMETER:: TCS_TABS                =#0000
INTEGER,PARAMETER:: TCS_BUTTONS             =#0100
INTEGER,PARAMETER:: TCS_SINGLELINE          =#0000
INTEGER,PARAMETER:: TCS_MULTILINE           =#0200
INTEGER,PARAMETER:: TCS_RIGHTJUSTIFY        =#0000
INTEGER,PARAMETER:: TCS_FIXEDWIDTH          =#0400
INTEGER,PARAMETER:: TCS_RAGGEDRIGHT         =#0800
INTEGER,PARAMETER:: TCS_FOCUSONBUTTONDOWN   =#1000
INTEGER,PARAMETER:: TCS_OWNERDRAWFIXED      =#2000
INTEGER,PARAMETER:: TCS_TOOLTIPS            =#4000
INTEGER,PARAMETER:: TCS_FOCUSNEVER          =#8000

INTEGER,PARAMETER:: TCM_FIRST               =#1300
INTEGER,PARAMETER:: TCM_GETIMAGELIST        =#1302
INTEGER,PARAMETER:: TCM_SETIMAGELIST        =#1303
INTEGER,PARAMETER:: TCM_GETITEMCOUNT        =#1304
INTEGER,PARAMETER:: TCM_GETITEM             =#1305
INTEGER,PARAMETER:: TCM_SETITEM             =#1306
INTEGER,PARAMETER:: TCM_INSERTITEM          =#1307
INTEGER,PARAMETER:: TCM_DELETEITEM          =#1308
INTEGER,PARAMETER:: TCM_DELETEALLITEMS      =#1309
INTEGER,PARAMETER:: TCM_GETITEMRECT         =#130A
INTEGER,PARAMETER:: TCM_GETCURSEL           =#130B
INTEGER,PARAMETER:: TCM_SETCURSEL           =#130C
INTEGER,PARAMETER:: TCM_HITTEST             =#130D
INTEGER,PARAMETER:: TCM_SETITEMEXTRA        =#130E
INTEGER,PARAMETER:: TCM_ADJUSTRECT          =#1328
INTEGER,PARAMETER:: TCM_SETITEMSIZE         =#1329
INTEGER,PARAMETER:: TCM_REMOVEIMAGE         =#132A
INTEGER,PARAMETER:: TCM_SETPADDING          =#132B
INTEGER,PARAMETER:: TCM_GETROWCOUNT         =#132C
INTEGER,PARAMETER:: TCM_GETTOOLTIPS         =#132D
INTEGER,PARAMETER:: TCM_SETTOOLTIPS         =#132E
INTEGER,PARAMETER:: TCM_GETCURFOCUS         =#132F
INTEGER,PARAMETER:: TCM_SETCURFOCUS         =#1330

INTEGER,PARAMETER:: TCIF_TEXT               =#0001
INTEGER,PARAMETER:: TCIF_IMAGE              =#0002
INTEGER,PARAMETER:: TCIF_RTLREADING         =#0004
INTEGER,PARAMETER:: TCIF_PARAM              =#0008

TYPE T_TC_ITEMHEADER
    INTEGER mask
    INTEGER lpReserved1
    INTEGER lpReserved2
    INTEGER pszText
    INTEGER cchTextMax
    INTEGER iImage
END TYPE T_TC_ITEMHEADER

TYPE T_TC_ITEM
    INTEGER mask
    INTEGER lpReserved1
    INTEGER lpReserved2
    INTEGER pszText
    INTEGER cchTextMax
    INTEGER iImage
    INTEGER lparam
END TYPE T_TC_ITEM

TYPE T_TC_HITTESTINFO
    TYPE (COMT_POINT) pt
    INTEGER flags
END TYPE T_TC_HITTESTINFO

INTEGER,PARAMETER:: TCHT_NOWHERE            =#0001
INTEGER,PARAMETER:: TCHT_ONITEMICON         =#0002
INTEGER,PARAMETER:: TCHT_ONITEMLABEL        =#0004
INTEGER,PARAMETER:: TCHT_ONITEM             =#0006

!INTEGER,PARAMETER:: TCN_FIRST               =0U-550U=       == tab con

INTEGER,PARAMETER:: TCN_KEYDOWN             =-550
INTEGER,PARAMETER:: TCN_SELCHANGE           =-551
INTEGER,PARAMETER:: TCN_SELCHANGING         =-552

TYPE TC_KEYDOWN
    TYPE (T_NMHDR) hdr
    INTEGER(2) wVKey
    INTEGER flags
END TYPE TC_KEYDOWN


!==== Trackbars ============================================================


CHARACTER*18,PARAMETER:: TRACKBAR_CLASSA    ="msctls_trackbar32"C

INTEGER,PARAMETER:: TBS_AUTOTICKS           =#0001
INTEGER,PARAMETER:: TBS_VERT                =#0002
INTEGER,PARAMETER:: TBS_HORZ                =#0000
INTEGER,PARAMETER:: TBS_TOP                 =#0004
INTEGER,PARAMETER:: TBS_BOTTOM              =#0000
INTEGER,PARAMETER:: TBS_LEFT                =#0004
INTEGER,PARAMETER:: TBS_RIGHT               =#0000
INTEGER,PARAMETER:: TBS_BOTH                =#0008
INTEGER,PARAMETER:: TBS_NOTICKS             =#0010
INTEGER,PARAMETER:: TBS_ENABLESELRANGE      =#0020
INTEGER,PARAMETER:: TBS_FIXEDLENGTH         =#0040
INTEGER,PARAMETER:: TBS_NOTHUMB             =#0080

INTEGER,PARAMETER:: TBM_GETPOS              =WM_USER
INTEGER,PARAMETER:: TBM_GETRANGEMIN         =WM_USER+1
INTEGER,PARAMETER:: TBM_GETRANGEMAX         =WM_USER+2
INTEGER,PARAMETER:: TBM_GETTIC              =WM_USER+3
INTEGER,PARAMETER:: TBM_SETTIC              =WM_USER+4
INTEGER,PARAMETER:: TBM_SETPOS              =WM_USER+5
INTEGER,PARAMETER:: TBM_SETRANGE            =WM_USER+6
INTEGER,PARAMETER:: TBM_SETRANGEMIN         =WM_USER+7
INTEGER,PARAMETER:: TBM_SETRANGEMAX         =WM_USER+8
INTEGER,PARAMETER:: TBM_CLEARTICS           =WM_USER+9
INTEGER,PARAMETER:: TBM_SETSEL              =WM_USER+10
INTEGER,PARAMETER:: TBM_SETSELSTART         =WM_USER+11
INTEGER,PARAMETER:: TBM_SETSELEND           =WM_USER+12
INTEGER,PARAMETER:: TBM_GETPTICS            =WM_USER+14
INTEGER,PARAMETER:: TBM_GETTICPOS           =WM_USER+15
INTEGER,PARAMETER:: TBM_GETNUMTICS          =WM_USER+16
INTEGER,PARAMETER:: TBM_GETSELSTART         =WM_USER+17
INTEGER,PARAMETER:: TBM_GETSELEND           =WM_USER+18
INTEGER,PARAMETER:: TBM_CLEARSEL            =WM_USER+19
INTEGER,PARAMETER:: TBM_SETTICFREQ          =WM_USER+20
INTEGER,PARAMETER:: TBM_SETPAGESIZE         =WM_USER+21
INTEGER,PARAMETER:: TBM_GETPAGESIZE         =WM_USER+22
INTEGER,PARAMETER:: TBM_SETLINESIZE         =WM_USER+23
INTEGER,PARAMETER:: TBM_GETLINESIZE         =WM_USER+24
INTEGER,PARAMETER:: TBM_GETTHUMBRECT        =WM_USER+25
INTEGER,PARAMETER:: TBM_GETCHANNELRECT      =WM_USER+26
INTEGER,PARAMETER:: TBM_SETTHUMBLENGTH      =WM_USER+27
INTEGER,PARAMETER:: TBM_GETTHUMBLENGTH      =WM_USER+28

INTEGER,PARAMETER:: TB_LINEUP               =0
INTEGER,PARAMETER:: TB_LINEDOWN             =1
INTEGER,PARAMETER:: TB_PAGEUP               =2
INTEGER,PARAMETER:: TB_PAGEDOWN             =3
INTEGER,PARAMETER:: TB_THUMBPOSITION        =4
INTEGER,PARAMETER:: TB_THUMBTRACK           =5
INTEGER,PARAMETER:: TB_TOP                  =6
INTEGER,PARAMETER:: TB_BOTTOM               =7
INTEGER,PARAMETER:: TB_ENDTRACK             =8

!==== Edit Boxes ============================================================

INTEGER,PARAMETER:: EM_SETMARGINS           =#00D3
INTEGER,PARAMETER:: EM_GETMARGINS           =#00D4
INTEGER,PARAMETER:: EM_SETLIMITTEXT         =#00C5
INTEGER,PARAMETER:: EM_GETLIMITTEXT         =#00D5
INTEGER,PARAMETER:: EM_POSFROMCHAR          =#00D6
INTEGER,PARAMETER:: EM_CHARFROMPOS          =#00D7

!==== Edit Boxes ============================================================

INTEGER,PARAMETER:: SS_OWNERDRAW        =#0000000D
INTEGER,PARAMETER:: SS_ENHMETAFILE      =#0000000F
INTEGER,PARAMETER:: SS_ETCHEDHORZ       =#00000010
INTEGER,PARAMETER:: SS_ETCHEDVERT       =#00000011
INTEGER,PARAMETER:: SS_ETCHEDFRAME      =#00000012
INTEGER,PARAMETER:: SS_TYPEMASK         =#0000001F
INTEGER,PARAMETER:: SS_NOPREFIX         =#00000080
INTEGER,PARAMETER:: SS_NOTIFY           =#00000100
INTEGER,PARAMETER:: SS_CENTERIMAGE      =#00000200
INTEGER,PARAMETER:: SS_RIGHTJUST        =#00000400
INTEGER,PARAMETER:: SS_REALSIZEIMAGE    =#00000800
INTEGER,PARAMETER:: SS_SUNKEN           =#00001000

INTEGER,PARAMETER:: STM_SETIMAGE        =#0172
INTEGER,PARAMETER:: STM_GETIMAGE        =#0173

INTEGER,PARAMETER:: STN_CLICKED         =0
INTEGER,PARAMETER:: STN_DBLCLK          =1
INTEGER,PARAMETER:: STN_ENABLE          =2
INTEGER,PARAMETER:: STN_DISABLE         =3

INTEGER,PARAMETER:: STM_MSGMAX          =#0174

!==== DEVMODE ============================================================

TYPE  T_DEVMODE16
    BYTE dmDeviceName (CCHDEVICENAME )
    INTEGER*2 dmSpecVersion 
    INTEGER*2 dmDriverVersion 
    INTEGER*2 dmSize 
    INTEGER*2 dmDriverExtra 
    INTEGER*2 dmFields 
    INTEGER*2 dmOrientation 
    INTEGER*2 dmPaperSize 
    INTEGER*2 dmPaperLength 
    INTEGER*2 dmPaperWidth 
    INTEGER*2 dmScale 
    INTEGER*2 dmCopies 
    INTEGER*2 dmDefaultSource 
    INTEGER*2 dmPrintQuality 
    INTEGER*2 dmColor 
    INTEGER*2 dmDuplex 
    INTEGER*2 dmYResolution 
    INTEGER*2 dmTTOption 
    INTEGER*2 dmCollate 
    BYTE      dmFormName (CCHFORMNAME )
    INTEGER*2 dmUnusedPadding 
    INTEGER dmBitsPerPel 
    INTEGER dmPelsWidth 
    INTEGER dmPelsHeight 
    INTEGER dmDisplayFlags 
    INTEGER dmDisplayFrequency 
END TYPE  T_DEVMODE16
$ENDIF      !_DVF

END MODULE COMCTLTY
$ENDIF      !COMCTLTY

